<template>
  <div>
    <v-card-title v-if="success" class="mt-12 justify-center flex-column">
      <v-icon>mdi-account-check</v-icon>

      <div>Авторизация успешна!</div>
    </v-card-title>

    <div v-else class="mx-auto mt-12 max-width-600">
      <v-card-title class="justify-center">
        {{ $t('main-words.auth') }}
      </v-card-title>

      <v-form ref="form" lazy-validation @submit.prevent="submit">
        <v-container class="text-center">
          <v-text-field
            v-model="form.email"
            :rules="[rules.required, rules.email]"
            :label="$t('main-words.email')"
            solo
            required
          />

          <v-text-field
            v-model="form.password"
            :rules="[rules.required, rules.password]"
            :label="$t('main-words.password')"
            type="password"
            solo
            required
          />

          <div style="text-align: start !important" class="mb-4">
            <div><b class="d-block">User Secret "r":</b> {{ oprfSk }}</div>
            <div><b class="d-block">Session ID:</b> {{ authId }}</div>
          </div>

          <v-btn :loading="loading" color="deep-orange" type="submit" dark>
            {{ $t('main-words.sign-in') }}
          </v-btn>
        </v-container>
      </v-form>
    </div>

    <v-divider class="my-4" />

    <div>
      <div><b class="d-block">Password hash point:</b> {{ point }}</div>
      <div><b class="d-block">Masked point "m":</b> {{ maskPoint }}</div>
    </div>

    <v-divider class="my-4" />

    <div>
      <div>
        <b class="d-block">Masked salt point "m":</b> {{ maskSaltPoint }}
      </div>
      <div><b class="d-block">Cipher key:</b> {{ cipherKey }}</div>
      <div><b class="d-block">Cipher:</b> {{ cipher }}</div>
      <div><b class="d-block">Decrypted SK:</b> {{ sk }}</div>
      <div><b class="d-block">Decrypted PK:</b> {{ pk }}</div>
      <div><b class="d-block">Decrypted Server PK:</b> {{ serverPk }}</div>
    </div>

    <v-divider class="my-4" />

    <div>
      <div><b class="d-block">Session key:</b> {{ sessionKey }}</div>
    </div>
  </div>
</template>

<script>
  import { sendMixin } from '@/mixins/send'

  import {
    emailRuleMixin,
    passwordRuleMixin,
    requiredRuleMixin,
  } from '@/mixins/validation'

  import { LoginService } from '@/services/LoginService'
  import { OprfService } from '@/services/OprfService'

  export default {
    name: 'Login',
    mixins: [sendMixin, requiredRuleMixin, emailRuleMixin, passwordRuleMixin],
    data: () => ({
      form: {
        email: '',
        password: '',
      },
      success: false,
      oprfSk: '',
      hash: '',
      point: '',
      maskPoint: '',
      maskSaltPoint: '',
      serverOprfPk: '',
      serverPk: '',
      authId: '',
      cipherKey: '',
      cipher: '',
      cipherDecode: '',
      pk: '',
      sessionKey: '',
    }),
    computed: {
      url() {
        return LoginService.URL
      },
    },
    mounted() {
      this.oprfSk = this.getOprfSk()
      this.authId = this.getAuthId()
    },
    methods: {
      async submit() {
        if (!this.$refs.form.validate() || this.loading) return

        await this.loginStart(this.getAuthId(), this.getOprfSk())
      },

      getOprfSk() {
        const oprfSk = localStorage.getItem('oprfSk')

        return oprfSk ? new Uint8Array(Object.values(JSON.parse(oprfSk))) : ''
      },

      getAuthId() {
        return localStorage.getItem('authId')
      },

      async loginStart(authId, oprfSk) {
        // eslint-disable-next-line no-unused-vars,no-redeclare
        const { email, hash, point, challenge } = await LoginService.start(
          this.form,
          oprfSk
        )

        this.hash = hash

        this.point = point

        this.maskPoint = OprfService.decodePoint(challenge)

        const params = { email, challenge, authId }

        try {
          const res = await this.sendData(this.url, 'post', params)

          await this.loginFinish(authId, oprfSk, res)
        } catch (e) {
          console.log(e)
        }
      },

      async loginFinish(authId, oprfSk, res) {
        this.maskSaltPoint = OprfService.decodePoint(res.challenge)

        this.serverOprfPk = OprfService.decodePoint(res.oprfPk)

        const { ciphertext } = JSON.parse(res.envelope)

        this.cipher = new Uint8Array(Object.values(ciphertext))

        // eslint-disable-next-line no-unused-vars
        const params = await LoginService.finish(
          this.form.password,
          oprfSk,
          res.envelope,
          res.challenge,
          res.oprfPk
        )

        this.cipherKey = params.key

        this.pk = params.userPk
        this.serverPk = params.serverPk
        this.sk = params.userSk

        this.sessionKey = params.encryptKey + params.decryptKey

        params.email = this.form.email

        try {
          const res = await this.sendData(
            `${this.url}/${authId}`,
            'put',
            params
          )

          this.success = res

          console.log(res)
        } catch (e) {
          console.log(e)
        }
      },
    },
  }
</script>

<style scoped></style>
